diff -uNrd ircd-hybrid-6.0/src/match.c ircd-pi1.0a/src/match.c
--- ircd-hybrid-6.0/src/match.c	Thu Sep 14 01:22:02 2000
+++ ircd-pi1.0a/src/match.c	Fri May 10 11:32:19 2002
@@ -22,12 +22,14 @@
  * Cleanup of collapse and match
  * Moved static calls variable to match
  * Added asserts for null pointers
- * $Id: match.c,v 1.25 2000/09/14 05:22:02 lusky Exp $
+ * $Id: match.c,v 1.10 2002/05/10 15:32:19 smoli Exp $
  *
  */
 #include "irc_string.h"
 #include "config.h"      /* RFC1035_ANAL */
+
 #include <assert.h>
+#include <string.h>
 
 /*
 **  Compare if a given string (name) matches the given
@@ -148,7 +150,8 @@
    * XXX - null pointers ok?
    */
   if (s) {
-    for (; *s; s++) {
+                                                                                                                                                                                                                                    
+for (; *s; s++) {
       if ('*' == *s) {
         t = s1 = s + 1;
         while ('*' == *t)
@@ -163,46 +166,6 @@
   return pattern;
 }
 
-/*
- * irccmp - case insensitive comparison of two 0 terminated strings.
- *
- *      returns  0, if s1 equal to s2
- *              <0, if s1 lexicographically less than s2
- *              >0, if s1 lexicographically greater than s2
- */
-int irccmp(const char *s1, const char *s2)
-{
-  const unsigned char* str1 = (const unsigned char*) s1;
-  const unsigned char* str2 = (const unsigned char*) s2;
-  int   res;
-  assert(0 != s1);
-  assert(0 != s2);
-
-  while ((res = ToUpper(*str1) - ToUpper(*str2)) == 0) {
-    if (*str1 == '\0')
-      return 0;
-    str1++;
-    str2++;
-  }
-  return (res);
-}
-
-int ircncmp(const char* s1, const char *s2, int n)
-{
-  const unsigned char* str1 = (const unsigned char*) s1;
-  const unsigned char* str2 = (const unsigned char*) s2;
-  int res;
-  assert(0 != s1);
-  assert(0 != s2);
-
-  while ((res = ToUpper(*str1) - ToUpper(*str2)) == 0) {
-    str1++; str2++; n--;
-    if (n == 0 || (*str1 == '\0' && *str2 == '\0'))
-      return 0;
-  }
-  return (res);
-}
-
 #ifdef NO_DUPE_MULTI_MESSAGES
 /*
 ** canonize
@@ -276,10 +239,10 @@
   0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf,
   0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8, 0xb9,
   0xba, 0xbb, 0xbc, 0xbd, 0xbe, 0xbf,
-  0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9,
-  0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
-  0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9,
-  0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
+  0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
+  0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
+  0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9,
+  0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xdf,
   0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
   0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
   0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9,
@@ -315,10 +278,10 @@
   0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
   0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9,
   0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
-  0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
-  0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
-  0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9,
-  0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff 
+  0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9,
+  0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
+  0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9,
+  0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xff
 };
 
 /*
@@ -532,70 +495,70 @@
 /* 0xBD */   CHAN_C|NONEOS_C,
 /* 0xBE */   CHAN_C|NONEOS_C,
 /* 0xBF */   CHAN_C|NONEOS_C,
-/* 0xC0 */   CHAN_C|NONEOS_C,
-/* 0xC1 */   CHAN_C|NONEOS_C,
-/* 0xC2 */   CHAN_C|NONEOS_C,
-/* 0xC3 */   CHAN_C|NONEOS_C,
-/* 0xC4 */   CHAN_C|NONEOS_C,
-/* 0xC5 */   CHAN_C|NONEOS_C,
-/* 0xC6 */   CHAN_C|NONEOS_C,
-/* 0xC7 */   CHAN_C|NONEOS_C,
-/* 0xC8 */   CHAN_C|NONEOS_C,
-/* 0xC9 */   CHAN_C|NONEOS_C,
-/* 0xCA */   CHAN_C|NONEOS_C,
-/* 0xCB */   CHAN_C|NONEOS_C,
-/* 0xCC */   CHAN_C|NONEOS_C,
-/* 0xCD */   CHAN_C|NONEOS_C,
-/* 0xCE */   CHAN_C|NONEOS_C,
-/* 0xCF */   CHAN_C|NONEOS_C,
-/* 0xD0 */   CHAN_C|NONEOS_C,
-/* 0xD1 */   CHAN_C|NONEOS_C,
-/* 0xD2 */   CHAN_C|NONEOS_C,
-/* 0xD3 */   CHAN_C|NONEOS_C,
-/* 0xD4 */   CHAN_C|NONEOS_C,
-/* 0xD5 */   CHAN_C|NONEOS_C,
-/* 0xD6 */   CHAN_C|NONEOS_C,
-/* 0xD7 */   CHAN_C|NONEOS_C,
-/* 0xD8 */   CHAN_C|NONEOS_C,
-/* 0xD9 */   CHAN_C|NONEOS_C,
-/* 0xDA */   CHAN_C|NONEOS_C,
-/* 0xDB */   CHAN_C|NONEOS_C,
-/* 0xDC */   CHAN_C|NONEOS_C,
-/* 0xDD */   CHAN_C|NONEOS_C,
-/* 0xDE */   CHAN_C|NONEOS_C,
-/* 0xDF */   CHAN_C|NONEOS_C,
-/* 0xE0 */   CHAN_C|NONEOS_C,
-/* 0xE1 */   CHAN_C|NONEOS_C,
-/* 0xE2 */   CHAN_C|NONEOS_C,
-/* 0xE3 */   CHAN_C|NONEOS_C,
-/* 0xE4 */   CHAN_C|NONEOS_C,
-/* 0xE5 */   CHAN_C|NONEOS_C,
-/* 0xE6 */   CHAN_C|NONEOS_C,
-/* 0xE7 */   CHAN_C|NONEOS_C,
-/* 0xE8 */   CHAN_C|NONEOS_C,
-/* 0xE9 */   CHAN_C|NONEOS_C,
-/* 0xEA */   CHAN_C|NONEOS_C,
-/* 0xEB */   CHAN_C|NONEOS_C,
-/* 0xEC */   CHAN_C|NONEOS_C,
-/* 0xED */   CHAN_C|NONEOS_C,
-/* 0xEE */   CHAN_C|NONEOS_C,
-/* 0xEF */   CHAN_C|NONEOS_C,
-/* 0xF0 */   CHAN_C|NONEOS_C,
-/* 0xF1 */   CHAN_C|NONEOS_C,
-/* 0xF2 */   CHAN_C|NONEOS_C,
-/* 0xF3 */   CHAN_C|NONEOS_C,
-/* 0xF4 */   CHAN_C|NONEOS_C,
-/* 0xF5 */   CHAN_C|NONEOS_C,
-/* 0xF6 */   CHAN_C|NONEOS_C,
-/* 0xF7 */   CHAN_C|NONEOS_C,
-/* 0xF8 */   CHAN_C|NONEOS_C,
-/* 0xF9 */   CHAN_C|NONEOS_C,
-/* 0xFA */   CHAN_C|NONEOS_C,
-/* 0xFB */   CHAN_C|NONEOS_C,
-/* 0xFC */   CHAN_C|NONEOS_C,
-/* 0xFD */   CHAN_C|NONEOS_C,
-/* 0xFE */   CHAN_C|NONEOS_C,
-/* 0xFF */   CHAN_C|NONEOS_C
+/* 0xC0 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xC1 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xC2 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xC3 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xC4 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xC5 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xC6 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xC7 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xC8 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xC9 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xCA */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xCB */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xCC */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xCD */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xCE */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xCF */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xD0 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xD1 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xD2 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xD3 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xD4 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xD5 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xD6 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xD7 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xD8 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xD9 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xDA */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xDB */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xDC */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xDD */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xDE */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xDF */   CHAN_C|NONEOS_C|ALPHA_C,
+/* 0xE0 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xE1 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xE2 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xE3 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xE4 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xE5 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xE6 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xE7 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xE8 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xE9 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xEA */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xEB */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xEC */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xED */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xEE */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xEF */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xF0 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xF1 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xF2 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xF3 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xF4 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xF5 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xF6 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xF7 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xF8 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xF9 */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xFA */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xFB */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xFC */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xFD */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xFE */   CHAN_C|NONEOS_C|ALPHA_C|NICK_C,
+/* 0xFF */   CHAN_C|NONEOS_C|ALPHA_C
 };
 
 
diff -uNrd ircd-hybrid-6.0/src/messages.tab ircd-pi1.0a/src/messages.tab
--- ircd-hybrid-6.0/src/messages.tab	Sat Dec 30 19:12:01 2000
+++ ircd-pi1.0a/src/messages.tab	Thu May 23 14:04:28 2002
@@ -1,5 +1,5 @@
 /************************************************************************
- *   IRC - Internet Relay Chat, src/messages.tab
+ *   IRC - Internet Relay Chat, ircd/messages_cust.tab
  *   Copyright (C) 1992 Darren Reed
  *
  *   This program is free software; you can redistribute it and/or modify
@@ -16,10 +16,11 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
+ * $Id: messages.tab,v 1.7 2002/05/23 18:04:28 smoli Exp $
  *
- *      I kind of modernized this code a bit. -Dianora
- *
- *   $Id: messages.tab,v 1.13 2000/12/31 00:12:01 lusky Exp $
+ */
+/* 
+ * jive replies originally from mr_bill - mrbill@mrbill.net (Bill Bradford) 
  */
 
 static  char *  replies[] = {
@@ -27,7 +28,11 @@
 /* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the Internet Relay Network %s",
 /* 002  RPL_YOURHOST,*/ ":%s 002 %s :Your host is %s, running version %s",
 /* 003  RPL_CREATED, */ ":%s 003 %s :This server was created %s",
-/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcrkfydnxb biklmnopstved",
+#ifdef HAVE_SSL
+/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcrkfydnxbe biklmnopstvedxz",
+#else
+/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcrkfydnxbe biklmnopstvedxz",
+#endif
 /* 005 */       (char *)NULL,
 /* 006 */       (char *)NULL,
 /* 007 */       (char *)NULL,
@@ -248,8 +253,8 @@
 /* 222 */       (char *)NULL,
 /* 223 */       (char *)NULL,
 /* 224 */       (char *)NULL,
-/* 225 RPL_STATSDLINE*/         ":%s 225 %s %c %s %s",
-/* 226 */       (char *)NULL,
+/* 225 RPL_STATSDLINE, */       ":%s 225 %s %c %s %s",
+/* 226 RPL_STATSSSL, */         ":%s 226 %s %d :%s",
 /* 227 */       (char *)NULL,
 /* 228 */       (char *)NULL,
 /* 229 */       (char *)NULL,
@@ -265,7 +270,7 @@
 /* 239 */       (char *)NULL,
 /* 240 */       (char *)NULL,
 /* 241 RPL_STATSLLINE, */       ":%s 241 %s %c %s * %s %d %d",
-/* 242 RPL_STATSUPTIME,*/       ":%s 242 %s :Server Up %d days, %d:%02d:%02d",
+/* 242 RPL_STATSUPTIME,*/       ":%s 242 %s :smoli hasn't messed with the server code now in %d days, %d:%02d:%02d",
 /* 243 RPL_STATSOLINE, */       ":%s 243 %s %c %s@%s * %s %s %d %s",
 /* 244 RPL_STATSHLINE, */       ":%s 244 %s %c %s * %s %d %d", 
 /* 245 RPL_STATSSLINE, */       ":%s 245 %s %c %s * %s %d %d", 
@@ -278,7 +283,7 @@
                     ":%s 250 %s :Highest connection count: %d (%d clients) (%d since server was (re)started)",
 /* 251 RPL_LUSERCLIENT, */
                 ":%s 251 %s :There are %d users and %d invisible on %d servers",
-/* 252 RPL_LUSEROP, */          ":%s 252 %s %d :IRC Operators online",
+/* 252 RPL_LUSEROP, */          ":%s 252 %s %d :drug addicts (operators) online",
 /* 253 RPL_LUSERUNKNOWN, */     ":%s 253 %s %d :unknown connection(s)",
 /* 254 RPL_LUSERCHANNELS, */    ":%s 254 %s %d :channels formed",
 /* 255 RPL_LUSERME, */          ":%s 255 %s :I have %d clients and %d servers",
@@ -289,21 +294,20 @@
 /* 260 */       (char *)NULL,
 /* 261 RPL_TRACELOG, */         ":%s 261 %s File %s %d",
 /* 262 RPL_ENDOFTRACE, */       ":%s 262 %s %s :End of TRACE",
-/* 263 RPL_LOAD2HI, */          
-":%s 263 %s :Server load is temporarily too heavy. Please wait a while and try again.",
+/* 263 RPL_LOAD2HI, */          ":%s 263 %s :What a sucking day! Load is too high, try again later.",
 /* 264 */       (char *)NULL,
-/* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d  Max: %d",
-/* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d  Max: %d",
-/* 267 */       (char *)NULL,
-/* 268 */       (char *)NULL,
+/* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d Max: %d",
+/* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d Max: %d",
+/* 267 RPL_LOCALSSL, */         ":%s 267 %s :Current local  SSL users: %d Max: %d",
+/* 268 RPL_REACHSSL, */         ":%s 268 %s :Current global SSL users: %d Max: %d",
 /* 269 */       (char *)NULL,
 /* 270 */       (char *)NULL,
 /* 271 */       (char *)NULL,
 /* 272 */       (char *)NULL,
 /* 273 */       (char *)NULL,
 /* 274 */       (char *)NULL,
-/* 275 */       (char *)NULL,
-/* 276 */       (char *)NULL,
+/* 275 RPL_WHOISSSL, */         ":%s 275 %s %s :is paranoid (SSL connection)",
+/* 276 RPL_NOTSSL, */           ":%s 276 %s :Client unreachable by SSL",
 /* 277 */       (char *)NULL,
 /* 278 */       (char *)NULL,
 /* 279 */       (char *)NULL,
@@ -327,23 +331,23 @@
 /* 296 */       (char *)NULL,
 /* 298 */       (char *)NULL,
 /* 299 */       (char *)NULL,
-/* 300 RPL_NONE, */      (char *)NULL,
-/* 301 RPL_AWAY, */      ":%s 301 %s %s :%s",
+/* 300 RPL_NONE, */     (char *)NULL,
+/* 301 RPL_AWAY, */     ":%s 301 %s %s :%s",
 /* 302 RPL_USERHOST, */  ":%s 302 %s :%s",
 /* 303 RPL_ISON, */     ":%s 303 %s :",
 /* 304 RPL_TEXT, */      (char *)NULL,
-/* 305 RPL_UNAWAY, */   ":%s 305 %s :You are no longer marked as being away",
-/* 306 RPL_NOWAWAY, */  ":%s 306 %s :You have been marked as being away",
+/* 305 RPL_UNAWAY, */   ":%s 305 %s :Did you have a nice time? (unaway)",
+/* 306 RPL_NOWAWAY, */  ":%s 306 %s :Hurry back! (away)",
 /* 307 */       (char *)NULL,
 /* 308 */       (char *)NULL,
-/* 309 */       (char *)NULL,
-/* 310 */       (char *)NULL,
+/* 309 RPL_WHOISINFO */         ":%s 309 %s %s :%s",
+/* 310 RPL_WHOISENFORCE */      ":%s 310 %s %s :is an absolute fuck-face",
 /* 311 RPL_WHOISUSER, */        ":%s 311 %s %s %s %s * :%s",
 /* 312 RPL_WHOISSERVER, */      ":%s 312 %s %s %s :%s",
-/* 313 RPL_WHOISOPERATOR, */    ":%s 313 %s %s :is an IRC Operator",
+/* 313 RPL_WHOISOPERATOR, */    ":%s 313 %s %s :is a drug addict (IRC operator)",
 /* 314 RPL_WHOWASUSER, */       ":%s 314 %s %s %s %s * :%s",
 /* 315 RPL_ENDOFWHO, */         ":%s 315 %s %s :End of /WHO list.",
-/* 316 RPL_WHOISCHANOP, */      (char *)NULL,
+/* 316 */       (char *)NULL,
 /* 317 RPL_WHOISIDLE, */        ":%s 317 %s %s %d %d :seconds idle, signon time",
 /* 318 RPL_ENDOFWHOIS, */       ":%s 318 %s %s :End of /WHOIS list.",
 /* 319 RPL_WHOISCHANNELS, */    ":%s 319 %s %s :%s",
@@ -399,7 +403,11 @@
 /* 361 RPL_KILLDONE, */ (char *)NULL,
 /* 362 RPL_CLOSING, */          ":%s 362 %s %s :Closed. Status = %d",
 /* 363 RPL_CLOSEEND, */         ":%s 363 %s %d: Connections Closed",
+#ifdef HAVE_SSL
+/* 364 RPL_LINKS, */            ":%s 364 %s %s %s :%d%s %s",
+#else
 /* 364 RPL_LINKS, */            ":%s 364 %s %s %s :%d %s",
+#endif
 /* 365 RPL_ENDOFLINKS, */       ":%s 365 %s %s :End of /LINKS list.",
 /* 366 RPL_ENDOFNAMES, */       ":%s 366 %s %s :End of /NAMES list.",
 #ifdef BAN_INFO
@@ -420,8 +428,8 @@
 /* 378 */       (char *)NULL,
 /* 379 */       (char *)NULL,
 /* 380 */       (char *)NULL,
-/* 381 RPL_YOUREOPER, */        ":%s 381 %s :You have entered... the Twilight Zone!.",
-/* 382 RPL_REHASHING, */        ":%s 382 %s %s :Rehashing",
+/* 381 RPL_YOUREOPER, */        ":%s 381 %s :You are now one bad motherfucker - Go /kill someone.",
+/* 382 RPL_REHASHING, */        ":%s 382 %s %s :it slices, dices, and even reloads config files! Rehashing config file, mang.",
 /* 383 */       (char *)NULL,
 /* 384 RPL_MYPORTIS, */         ":%s 384 %s %d :Port to local server is\r\n",
 /* 385 RPL_NOTOPERANYMORE, */   (char *)NULL,
@@ -474,7 +482,7 @@
 /* 430 */       (char *)NULL,
 /* 431 ERR_NONICKNAMEGIVEN, */  ":%s 431 %s :No nickname given",
 /* 432 ERR_ERRONEUSNICKNAME, */ ":%s 432 %s %s :Erroneus Nickname",
-/* 433 ERR_NICKNAMEINUSE, */    ":%s 433 %s %s :Nickname is already in use.",
+/* 433 ERR_NICKNAMEINUSE, */    ":%s 433 %s %s :Doh! Looks like someone stole your nick, doesn't it?",
 /* 434 */       (char *)NULL,
 /* 435 */       (char *)NULL,
 /* 436 ERR_NICKCOLLISION, */    ":%s 436 %s %s :Nickname collision KILL",
@@ -505,27 +513,27 @@
 /* 461 ERR_NEEDMOREPARAMS, */   ":%s 461 %s %s :Not enough parameters",
 /* 462 ERR_ALREADYREGISTRED, */ ":%s 462 %s :You may not reregister",
 /* 463 ERR_NOPERMFORHOST, */    ":%s 463 %s :Your host isn't among the privileged",
-/* 464 ERR_PASSWDMISMATCH, */   ":%s 464 %s :Password Incorrect",
+/* 464 ERR_PASSWDMISMATCH, */   ":%s 464 %s :Wrong password, dude. Are you sure you know what you're doing??",
 /* 465 ERR_YOUREBANNEDCREEP, */ ":%s 465 %s :You are banned from this server- %s",
 /* 466 ERR_YOUWILLBEBANNED, */  (char *)NULL,
 /* 467 ERR_KEYSET, */           ":%s 467 %s %s :Channel key already set",
 /* 468 */       (char *)NULL,
 /* 469 */       (char *)NULL,
-/* 470 */       (char *)NULL,
-/* 471 ERR_CHANNELISFULL, */    ":%s 471 %s %s :Cannot join channel (+l)",
+/* 470 ERR_NEEDSSL, */          ":%s 470 %s %s :You're not paranoid enough",
+/* 471 ERR_CHANNELISFULL, */    ":%s 471 %s %s :Too much dudes in there.",
 /* 472 ERR_UNKNOWNMODE  , */    ":%s 472 %s %c :is unknown mode char to me",
-/* 473 ERR_INVITEONLYCHAN, */   ":%s 473 %s %s :Cannot join channel (+i)",
-/* 474 ERR_BANNEDFROMCHAN, */   ":%s 474 %s %s :Cannot join channel (+b)",
-/* 475 ERR_BADCHANNELKEY, */    ":%s 475 %s %s :Cannot join channel (+k)",
+/* 473 ERR_INVITEONLYCHAN, */   ":%s 473 %s %s :Private party, your invitation please!?",
+/* 474 ERR_BANNEDFROMCHAN, */   ":%s 474 %s %s :You're banned creep!",
+/* 475 ERR_BADCHANNELKEY, */    ":%s 475 %s %s :Knowing the key would be useful, wouldn't it?",
 /* 476 ERR_BADCHANMASK, */      ":%s 476 %s %s :Bad Channel Mask",
 /* 477 ERR_MODELESS, */         ":%s 477 %s %s :Channel does not support modes",
 /* 478 ERR_BANLISTFULL, */      ":%s 478 %s %s %s :Channel ban list is full",
 /* 479 ERR_BADCHANNAME */       ":%s 479 %s %s :Illegal channel name",
-/* 480 */       (char *)NULL,
+/* 480 */	(char *)NULL,
 /* 481 ERR_NOPRIVILEGES, */
-                ":%s 481 %s :Permission Denied- You're not an IRC operator",
-/* 482 ERR_CHANOPRIVSNEEDED, */ ":%s 482 %s %s :You're not channel operator",
-/* 483 ERR_CANTKILLSERVER, */   ":%s 483 %s :You can't kill a server!",
+                ":%s 481 %s :In your dreams, dude! But not here!",
+/* 482 ERR_CHANOPRIVSNEEDED, */ ":%s 482 %s %s :How about beeing channel operator first?",
+/* 483 ERR_CANTKILLSERVER, */    ":%s 483 %s :Don't be an idiot - you can't kill a SERVER, fool.",
 /* 484 */       (char *)NULL,
 /* 485 */       (char *)NULL,
 /* 486 */       (char *)NULL,
@@ -533,7 +541,7 @@
 /* 488 */       (char *)NULL,
 /* 489 */       (char *)NULL,
 /* 490 */       (char *)NULL,
-/* 491 ERR_NOOPERHOST, */       ":%s 491 %s :Only few of mere mortals may try to enter the twilight zone",
+/* 491 ERR_NOOPERHOST, */       ":%s 491 %s :Do I know you?",
 /* 492 */       (char *)NULL,
 /* 493 */       (char *)NULL,
 /* 494 */       (char *)NULL,
diff -uNrd ircd-hybrid-6.0/src/motd.c ircd-pi1.0a/src/motd.c
--- ircd-hybrid-6.0/src/motd.c	Wed Aug 25 18:58:22 1999
+++ ircd-pi1.0a/src/motd.c	Fri Nov  2 19:23:36 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: motd.c,v 1.22 1999/08/25 22:58:22 lusky Exp $
+ *   $Id: motd.c,v 1.1.1.1 2001/11/03 00:23:36 shifty Exp $
  */
 #include "motd.h"
 #include "ircd.h"
diff -uNrd ircd-hybrid-6.0/src/mtrie_conf.c ircd-pi1.0a/src/mtrie_conf.c
--- ircd-hybrid-6.0/src/mtrie_conf.c	Fri Dec  1 01:28:49 2000
+++ ircd-pi1.0a/src/mtrie_conf.c	Fri May 10 23:49:05 2002
@@ -43,7 +43,7 @@
  *
  * Diane Bruce -db (db@db.net)
  *
- * $Id: mtrie_conf.c,v 1.71 2000/12/01 06:28:49 lusky Exp $
+ * $Id: mtrie_conf.c,v 1.2 2002/05/11 03:49:05 smoli Exp $
  */
 #include "mtrie_conf.h"
 #include "class.h"
@@ -1151,7 +1151,7 @@
   int two_letter_tld = 0;
   char tokenized_host[HOSTLEN+1];
 
-  if (strlen(host) > (size_t) HOSTLEN)
+  if (irclen(host) > (size_t) HOSTLEN)
     return;
 
   if(is_address(host,&ip_host,&ip_mask))
diff -uNrd ircd-hybrid-6.0/src/noarch/asmtest.c ircd-pi1.0a/src/noarch/asmtest.c
--- ircd-hybrid-6.0/src/noarch/asmtest.c	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/src/noarch/asmtest.c	Fri May 10 23:49:09 2002
@@ -0,0 +1,57 @@
+#include <stdio.h>
+#include <string.h>
+#include <sys/time.h>
+
+#include "irc_string.h"
+
+struct timezone tz = { 0, 0 };
+unsigned long stamp = 0;
+struct timeval tv;
+
+void profile_start()
+{
+  gettimeofday(&tv, &tz);
+  stamp = tv.tv_usec + tv.tv_sec * 1000000;
+}
+
+void profile_end(const char *function, const void *buf, unsigned long size, unsigned long bytes)
+{
+  unsigned long current;
+  unsigned long delta;
+  
+  gettimeofday(&tv, &tz);
+  current = tv.tv_usec + tv.tv_sec * 1000000;
+  delta = current - stamp;
+  
+  fprintf(stderr, "function: %s buf: %p size: %lu retval: %lu time: %lu usecs\n",
+          function, buf, size, bytes, delta);
+}
+
+int main()
+{
+  FILE *f;
+  char buf[131072];
+  char buf2[131072];
+  int l1, l2;
+  
+  f = fopen("/etc/services", "r");
+  
+  l1 = fread(buf, 100000, 1, f);
+  rewind(f);
+  fread(buf2, 100000, 1, f);
+  
+  profile_start();
+  l2 = irclen(&buf[1]);
+  profile_end("irclen()", buf, l1, l2);
+
+  profile_start();
+  l2 = irccmp(&buf[1], &buf2[1]);
+  profile_end("irccmp()", buf2, l1, l2);
+
+  profile_start();
+  l2 = ircncmp(&buf[1], &buf2[1], 1000000);
+  profile_end("ircncmp()", buf2, l1, l2);
+
+  printf("%d %d\n", !irccmp("TESTLINE", ""), strcmp("TESTLINE", ""));
+  return 0;
+}
diff -uNrd ircd-hybrid-6.0/src/noarch/irccmp.c ircd-pi1.0a/src/noarch/irccmp.c
--- ircd-hybrid-6.0/src/noarch/irccmp.c	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/src/noarch/irccmp.c	Sun May 19 00:27:48 2002
@@ -0,0 +1,22 @@
+#include <stdio.h>
+#include <assert.h>
+
+#include "irc_string.h"
+
+int irccmp(const char *s1, const char *s2)
+{
+  const unsigned char* str1 = (const unsigned char*) s1;
+  const unsigned char* str2 = (const unsigned char*) s2;
+  int res;
+  
+  while((res = (to_upper(*str1)) - (to_upper(*str2))) == 0)
+    {
+      if (*str1 == '\0')
+        return 0;
+      str1++;
+      str2++;
+    }
+  
+  return (res);
+}
+
diff -uNrd ircd-hybrid-6.0/src/noarch/irclen.c ircd-pi1.0a/src/noarch/irclen.c
--- ircd-hybrid-6.0/src/noarch/irclen.c	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/src/noarch/irclen.c	Fri May 10 21:30:44 2002
@@ -0,0 +1,13 @@
+#include "irc_string.h"
+
+size_t irclen(const char *s)
+{
+  register const char *x = s;
+  register size_t len = 0;
+  
+  while(*x++ != '\0')
+    len++;
+  
+  return len;
+}
+
diff -uNrd ircd-hybrid-6.0/src/noarch/ircncmp.c ircd-pi1.0a/src/noarch/ircncmp.c
--- ircd-hybrid-6.0/src/noarch/ircncmp.c	Wed Dec 31 19:00:00 1969
+++ ircd-pi1.0a/src/noarch/ircncmp.c	Fri May 10 21:30:44 2002
@@ -0,0 +1,22 @@
+#include <assert.h>
+#include "irc_string.h"
+
+int ircncmp(const char* s1, const char *s2, int n)
+{
+  const unsigned char* str1 = (const unsigned char*) s1;
+  const unsigned char* str2 = (const unsigned char*) s2;
+  int res;
+/*  assert(0 != s1);
+  assert(0 != s2);*/
+
+  while((res = to_upper(*str1) - to_upper(*str2)) == 0)
+    {
+      str1++; str2++; n--;
+    
+      if(n == 0 || (*str1 == '\0' && *str2 == '\0'))
+        return 0;
+    }
+  
+  return (res);
+}
+
diff -uNrd ircd-hybrid-6.0/src/numeric.c ircd-pi1.0a/src/numeric.c
--- ircd-hybrid-6.0/src/numeric.c	Wed Jul 28 18:27:46 1999
+++ ircd-pi1.0a/src/numeric.c	Fri May 10 01:32:24 2002
@@ -19,19 +19,16 @@
  *
  *      I kind of modernized this code a bit. -Dianora
  *
- *   $Id: numeric.c,v 1.3 1999/07/28 22:27:46 tomh Exp $
+ *   $Id: numeric.c,v 1.2 2002/05/10 05:32:24 smoli Exp $
  */
 #include "numeric.h"
 #include "irc_string.h"
 #include "common.h"     /* NULL cripes */
+#include "config.h"
 
 #include <assert.h>
 
-#ifdef CUSTOM_ERR            /* ZZZZ ick */
-#include "messages_cust.tab"
-#else
 #include "messages.tab"
-#endif
 
 
 /*
diff -uNrd ircd-hybrid-6.0/src/packet.c ircd-pi1.0a/src/packet.c
--- ircd-hybrid-6.0/src/packet.c	Fri Sep 10 00:54:19 1999
+++ ircd-pi1.0a/src/packet.c	Fri May 10 23:49:05 2002
@@ -18,7 +18,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- *   $Id: packet.c,v 1.23 1999/09/10 04:54:19 lusky Exp $
+ *   $Id: packet.c,v 1.5 2002/05/11 03:49:05 smoli Exp $
  */ 
 #include "packet.h"
 #include "client.h"
@@ -31,6 +31,7 @@
 #include "irc_string.h"
 
 #include <assert.h>
+#include <string.h>
 
 /*
 ** dopacket
@@ -253,7 +254,7 @@
   assert(0 != buffer);
 
   strncpy_irc(cptr->buffer, buffer, BUFSIZE);
-  length = strlen(cptr->buffer); 
+  length = irclen(cptr->buffer); 
 
   /* 
    * Update messages received
diff -uNrd ircd-hybrid-6.0/src/parse.c ircd-pi1.0a/src/parse.c
--- ircd-hybrid-6.0/src/parse.c	Fri Nov 24 13:24:37 2000
+++ ircd-pi1.0a/src/parse.c	Fri May 10 23:49:05 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: parse.c,v 1.42 2000/11/24 18:24:37 lusky Exp $
+ *   $Id: parse.c,v 1.4 2002/05/11 03:49:05 smoli Exp $
  */
 #include "parse.h"
 #include "channel.h"
@@ -395,10 +395,10 @@
   int c, c2, lp;
   MESSAGE_TREE *mtree1;
 
-  lp = strlen(prefix);
+  lp = irclen(prefix);
   if (!lp || !strncmp(mptr->cmd, prefix, lp))
     {
-      if (!mptr[1].cmd || (lp && strncmp(mptr[1].cmd, prefix, lp)))
+      if(!mptr[1].cmd || (lp && strncmp(mptr[1].cmd, prefix, lp)))
         {
           /* non ambiguous -> make a final case */
           mtree->final = mptr->cmd + lp;
@@ -410,7 +410,7 @@
       else
         {
           /* ambigous -> make new entries for each of the letters that match */
-          if (!irccmp(mptr->cmd, prefix))
+          if(!strcmp(mptr->cmd, prefix))
             {
               /* fucking OPERWALL blows me */
               mtree->final = (void *)1;
@@ -649,14 +649,23 @@
   aChannel *chptr;
   char  *nick, *p;
   int   i;
-
+#ifdef HAVE_SSL
+  int num = atoi(numeric);
+#endif
+  
   if (parc < 1 || !IsServer(sptr))
     return 0;
-
+  
   /* Remap low number numerics. */
   if(numeric[0] == '0')
     numeric[0] = '1';
 
+#ifdef HAVE_SSL
+  if(!IsSSL(cptr) && num == RPL_WHOISSSL)
+    return 0;                     /* ignore RPL_WHOISSSL which comes from
+                                   * unencrypted link */
+#endif
+  
   /*
   ** Prepare the parameter portion of the message into 'buffer'.
   ** (Because the buffer is twice as large as the message buffer
@@ -690,6 +699,11 @@
           ** with numerics which can happen with nick collisions.
           ** - Avalon
           */
+#ifdef HAVE_SSL
+          if(num == RPL_WHOISSSL && MyClient(acptr) && !IsSSL(acptr))
+            return 0;       /* ignore RPL_WHOISSSL which goes to unencrypted client */
+#endif          
+          
           if (!IsMe(acptr) && IsPerson(acptr))
             sendto_prefix_one(acptr, sptr,":%s %s %s%s",
                               parv[0], numeric, nick, buffer);
